)clear
⍝⍝⍝: link repo
r←⎕ns''
r.name←'xl'
⎕SE.git.setRepo r

⍝⍝⍝: Generate content for worksheets
Sheet1←'Test Sheet'
addr1 ←'A1'
val1  ←'text' 'test' 'excel' 'strings'
style ←0

⍝⍝⍝: Place values in the Worksheet
Worksheets.Add Sheet1 addr1 style val1

⍝⍝⍝: Add more values at different addresses
Worksheets.Add Sheet1 'A2' style (⍳9) 

⍝⍝⍝: Add values on the same line with spaces between
Worksheets.Add Sheet1 'F1' style (⍳9)

⍝⍝⍝: Add a matrix 
Worksheets.Add Sheet1 'C4' style (4 4⍴⍳9)

⍝⍝⍝: Add one more sheet
Worksheets.Add 'New Sheet' 'C4' style (4 4⍴⍳9)

⍝⍝⍝: Export to Demo.xlsx file
Build.Main'Demo'

⍝⍝⍝: Open the directory
⎕SH 'explorer .'

⍝⍝⍝: Let's start over and build a calendar
)erase Worksheets.Table

⍝⍝⍝: Days per month 2019
mdays←31 28 31 30 31 30 31 31 30 31 30 31

⍝⍝⍝: Month and Day Names
mnames←'Jan' 'Feb' 'Mar' 'Apr' 'May' 'Jun' 'Jul' 'Aug' 'Sep' 'Oct' 'Nov' 'Dec'
days←{∊⍵'day'}¨'Sun' 'Mon' 'Tues' 'Wednes' 'Thurs' 'Fri' 'Satur'

⍝⍝⍝: Generate month calendars
calMonths←(⊂1+⍳¨mdays){lm cm nm←⍺[12|¯1 0 1+⍵] ⋄ 6 7⍴(((-off)-2)↑lm),cm,((14-2)-off←⍵⌷7|+\0,¯1↓mdays)↑nm}¨⍳≢mdays

⍝⍝⍝: The cell block for each month. 1 row for month names, 1 for day names, 6 for calenard, 1 blank 
cellPos←↓(⍪9×⍳12),0

⍝⍝⍝: Add each dataset to Worksheets  Table
mLocs dLocs cLocs←{index2Cell¨(⊂⍵)+¨cellPos}¨(0 0)(1 0)(2 0)
mnames   {Worksheets.Add 'Calendar' ⍵ 'style' (⊆⍺)}¨mLocs
calMonths{Worksheets.Add 'Calendar' ⍵ 'style'   ⍺ }¨cLocs
days    ∘{Worksheets.Add 'Calendar' ⍵ 'style'   ⍺ }¨dLocs

⍝⍝⍝: Export to Demo.xlsx file
Build.Main'Demo'


⍝⍝⍝: Let's try a different calendar
)erase Worksheets.Table

calMonths{m←⍵⋄'A1' 'A2'{Worksheets.Add m ⍺ 'style' ⍵}¨days ⍺}¨mnames
⍝⍝⍝: Export to Demo.xlsx file
Build.Main'Demo'

⍝⍝⍝: Doesn't yet handle mixed data types
⍝⍝⍝: Doesn't yet understand styles, text or number formatting
⍝⍝⍝: Questions?

